## bro 2.5.5

=== doc/CMakeLists.txt ===
set(BROCCOLI_DOCS_SRC ${CMAKE_BINARY_DIR}/aux/broccoli/doc/html)
set(BROCCOLI_DOCS_DST ${CMAKE_BINARY_DIR}/html/broccoli-api)
set(SPHINX_INPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx_input)
set(SPHINX_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx_output)
set(BROXYGEN_SCRIPT_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/broxygen_script_output)
set(BROXYGEN_CACHE_DIR ${CMAKE_CURRENT_BINARY_DIR}/broxygen_cache)

# Find out what BROPATH to use when executing bro.
execute_process(COMMAND ${CMAKE_BINARY_DIR}/bro-path-dev
                OUTPUT_VARIABLE BROPATH
                RESULT_VARIABLE retval
                OUTPUT_STRIP_TRAILING_WHITESPACE)
if (NOT ${retval} EQUAL 0)
    message(FATAL_ERROR "Problem setting BROPATH")
endif ()

# Configure the Sphinx config file (expand variables CMake might know about).
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in
               ${CMAKE_CURRENT_BINARY_DIR}/conf.py
               @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/broxygen.conf.in
               ${CMAKE_CURRENT_BINARY_DIR}/broxygen.conf
               @ONLY)

add_custom_target(sphinxdoc
    # Copy the template documentation to build directory to use as input tree
    # for Sphinx.  This is needed because some parts are dynamically generated
    # in to that tree by Bro/Broxygen.
    COMMAND rsync -q -r --copy-links --times --delete
            --filter='protect scripts/*'
            ${CMAKE_CURRENT_SOURCE_DIR}/ ${SPHINX_INPUT_DIR}
    # Use Bro/Broxygen to dynamically generate reST for all Bro scripts.
    COMMAND BROPATH=${BROPATH}
            ${CMAKE_BINARY_DIR}/src/bro
            -X ${CMAKE_CURRENT_BINARY_DIR}/broxygen.conf
            broxygen >/dev/null
    # Rsync over the generated reST to the Sphinx source tree in the build dir.
    COMMAND rsync -q -r --copy-links --times --delete --filter='protect *.bro'
            ${BROXYGEN_SCRIPT_OUTPUT}/ ${SPHINX_INPUT_DIR}/scripts
    # Rsync over Bro scripts to the Sphinx source tree in the build dir.
    # These are used by :download: references in the generated script docs.
    COMMAND rsync -q -r --copy-links --times --delete
            --filter='protect /base/bif/*' --filter='protect *.rst'
            --filter='include */' --filter='include *.bro' --filter='exclude *'
            ${CMAKE_SOURCE_DIR}/scripts/ ${SPHINX_INPUT_DIR}/scripts
    # Rsync over Bro scripts created by BIF compiler to the Sphinx source tree.
    COMMAND rsync -q -r --copy-links --times --delete
            --filter='protect *.rst' --filter='include */'
            --filter='include *.bro' --filter='exclude *'
            ${CMAKE_BINARY_DIR}/scripts/base/bif/
            ${SPHINX_INPUT_DIR}/scripts/base/bif
    # Use Sphinx to build HTML.
    COMMAND sphinx-build
            -b html
            -c ${CMAKE_CURRENT_BINARY_DIR}
            -d ${SPHINX_OUTPUT_DIR}/doctrees
            ${SPHINX_INPUT_DIR}
            ${SPHINX_OUTPUT_DIR}/html
    # Create symlink to the html output directory for convenience.
    COMMAND "${CMAKE_COMMAND}" -E create_symlink
            ${SPHINX_OUTPUT_DIR}/html
            ${CMAKE_BINARY_DIR}/html
    # Copy Broccoli API reference into output dir if it exists.
    COMMAND test -d ${BROCCOLI_DOCS_SRC} &&
            ( rm -rf ${BROCCOLI_DOCS_DST} &&
              cp -r ${BROCCOLI_DOCS_SRC} ${BROCCOLI_DOCS_DST} ) || true
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "[Sphinx] Generate HTML documentation in ${CMAKE_BINARY_DIR}/html")

add_dependencies(sphinxdoc bro)

add_custom_target(sphinxdoc_clean
    COMMAND "${CMAKE_COMMAND}" -E remove_directory ${SPHINX_INPUT_DIR}
    COMMAND "${CMAKE_COMMAND}" -E remove_directory ${SPHINX_OUTPUT_DIR}
    COMMAND "${CMAKE_COMMAND}" -E remove_directory ${BROXYGEN_SCRIPT_OUTPUT}
    COMMAND "${CMAKE_COMMAND}" -E remove_directory ${BROXYGEN_CACHE_DIR}
    VERBATIM)

add_custom_target(doc)
add_custom_target(docclean)
add_dependencies(doc sphinxdoc)
add_dependencies(docclean sphinxdoc_clean)

=== src/analyzer/protocol/CMakeLists.txt ===

add_subdirectory(arp)
add_subdirectory(ayiya)
add_subdirectory(backdoor)
add_subdirectory(bittorrent)
add_subdirectory(conn-size)
add_subdirectory(dce-rpc)
add_subdirectory(dhcp)
add_subdirectory(dnp3)
add_subdirectory(dns)
add_subdirectory(file)
add_subdirectory(finger)
add_subdirectory(ftp)
add_subdirectory(gnutella)
add_subdirectory(gssapi)
add_subdirectory(gtpv1)
add_subdirectory(http)
add_subdirectory(icmp)
add_subdirectory(ident)
add_subdirectory(imap)
add_subdirectory(interconn)
add_subdirectory(irc)
add_subdirectory(krb)
add_subdirectory(login)
add_subdirectory(mime)
add_subdirectory(modbus)
add_subdirectory(mysql)
add_subdirectory(ncp)
add_subdirectory(netbios)
add_subdirectory(ntlm)
add_subdirectory(ntp)
add_subdirectory(pia)
add_subdirectory(pop3)
add_subdirectory(radius)
add_subdirectory(rdp)
add_subdirectory(rfb)
add_subdirectory(rpc)
add_subdirectory(sip)
add_subdirectory(snmp)
add_subdirectory(smb)
add_subdirectory(smtp)
add_subdirectory(socks)
add_subdirectory(ssh)
add_subdirectory(ssl)
add_subdirectory(stepping-stone)
add_subdirectory(syslog)
add_subdirectory(tcp)
add_subdirectory(teredo)
add_subdirectory(udp)
add_subdirectory(xmpp)
add_subdirectory(zip)

=== src/file_analysis/analyzer/CMakeLists.txt ===
add_subdirectory(data_event)
add_subdirectory(entropy)
add_subdirectory(extract)
add_subdirectory(hash)
add_subdirectory(pe)
add_subdirectory(unified2)
add_subdirectory(x509)

=== src/analyzer/protocol/file/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro File)
bro_plugin_cc(File.cc Plugin.cc)
bro_plugin_bif(events.bif)
bro_plugin_end()

=== src/analyzer/protocol/ftp/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro FTP)
bro_plugin_cc(FTP.cc Plugin.cc)
bro_plugin_bif(events.bif)
bro_plugin_bif(functions.bif)
bro_plugin_end()

=== src/analyzer/protocol/gnutella/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro Gnutella)
bro_plugin_cc(Gnutella.cc Plugin.cc)
bro_plugin_bif(events.bif)
bro_plugin_end()

=== src/analyzer/protocol/gssapi/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro GSSAPI)
bro_plugin_cc(GSSAPI.cc Plugin.cc)
bro_plugin_bif(events.bif)
bro_plugin_pac(
    gssapi.pac 
    gssapi-protocol.pac
    gssapi-analyzer.pac
    ../asn1/asn1.pac
    )
bro_plugin_end()

=== src/analyzer/protocol/ncp/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro NCP)
bro_plugin_cc(NCP.cc Plugin.cc)
bro_plugin_bif(events.bif consts.bif)
bro_plugin_pac(ncp.pac)
bro_plugin_end()

=== src/analyzer/protocol/rdp/CMakeLists.txt ===
include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro RDP)
	bro_plugin_cc(RDP.cc Plugin.cc)
	bro_plugin_bif(events.bif)
	bro_plugin_bif(types.bif)
	bro_plugin_pac(rdp.pac rdp-analyzer.pac rdp-protocol.pac ../asn1/asn1.pac)
bro_plugin_end()

=== src/analyzer/protocol/smb/CMakeLists.txt ===
include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
include_directories(AFTER  ${CMAKE_CURRENT_BINARY_DIR}/../dce-rpc)

bro_plugin_begin(Bro SMB)
bro_plugin_cc(SMB.cc Plugin.cc)
bro_plugin_bif(
	smb1_com_check_directory.bif
	smb1_com_close.bif
	smb1_com_create_directory.bif
	smb1_com_echo.bif
	smb1_com_logoff_andx.bif
	smb1_com_negotiate.bif
	smb1_com_nt_create_andx.bif
	smb1_com_nt_cancel.bif
	smb1_com_query_information.bif
	smb1_com_read_andx.bif
	smb1_com_session_setup_andx.bif
	smb1_com_transaction.bif
	smb1_com_transaction2.bif
	smb1_com_tree_connect_andx.bif
	smb1_com_tree_disconnect.bif
	smb1_com_write_andx.bif
	smb1_events.bif

	smb2_com_close.bif
	smb2_com_create.bif
	smb2_com_negotiate.bif
	smb2_com_read.bif
	smb2_com_session_setup.bif
	smb2_com_set_info.bif
	smb2_com_tree_connect.bif
	smb2_com_tree_disconnect.bif
	smb2_com_write.bif
	smb2_events.bif

	events.bif
	consts.bif

	types.bif)
bro_plugin_pac(
	smb.pac
	smb-common.pac
	smb-strings.pac
	smb-time.pac
	smb-pipe.pac
	smb-gssapi.pac
	smb-mailslot.pac

	smb1-protocol.pac
	smb1-com-check-directory.pac
	smb1-com-close.pac
	smb1-com-create-directory.pac
	smb1-com-echo.pac
	smb1-com-locking-andx.pac
	smb1-com-logoff-andx.pac
	smb1-com-negotiate.pac
	smb1-com-nt-cancel.pac
	smb1-com-nt-create-andx.pac
	smb1-com-nt-transact.pac
	smb1-com-query-information.pac
	smb1-com-read-andx.pac
	smb1-com-session-setup-andx.pac
	smb1-com-transaction-secondary.pac
	smb1-com-transaction.pac
	smb1-com-transaction2.pac
	smb1-com-tree-connect-andx.pac
	smb1-com-tree-disconnect.pac
	smb1-com-write-andx.pac

	smb2-protocol.pac
	smb2-com-close.pac
	smb2-com-create.pac
	smb2-com-ioctl.pac
	smb2-com-lock.pac
	smb2-com-negotiate.pac
	smb2-com-read.pac
	smb2-com-session-setup.pac
	smb2-com-set-info.pac
	smb2-com-tree-connect.pac
	smb2-com-tree-disconnect.pac
	smb2-com-write.pac
)
bro_plugin_end()

=== src/analyzer/protocol/ssl/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro SSL)
bro_plugin_cc(SSL.cc DTLS.cc Plugin.cc)
bro_plugin_bif(types.bif)
bro_plugin_bif(events.bif)
bro_plugin_bif(functions.bif)
bro_plugin_pac(tls-handshake.pac tls-handshake-protocol.pac tls-handshake-analyzer.pac ssl-defs.pac
	proc-client-hello.pac
	proc-server-hello.pac
	proc-certificate.pac
)
bro_plugin_pac(ssl.pac ssl-dtls-analyzer.pac ssl-analyzer.pac ssl-dtls-protocol.pac ssl-protocol.pac ssl-defs.pac
	proc-client-hello.pac
    proc-server-hello.pac
	proc-certificate.pac
)
bro_plugin_pac(dtls.pac ssl-dtls-analyzer.pac dtls-analyzer.pac ssl-dtls-protocol.pac dtls-protocol.pac ssl-defs.pac)
bro_plugin_end()

=== src/analyzer/protocol/teredo/CMakeLists.txt ===

include(BroPlugin)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

bro_plugin_begin(Bro Teredo)
bro_plugin_cc(Teredo.cc Plugin.cc)
bro_plugin_bif(events.bif)
bro_plugin_end()

=== debian/changelog ===
bro (2.5.5-1+deb10u1) buster-security; urgency=medium

  * Add patches for CVE-2018-16807, CVE-2018-17019 (Closes: #908614,
    #908779)

 -- Hilko Bengen <bengen@debian.org>  Tue, 25 Jun 2019 21:26:53 +0200

bro (2.5.5-1) unstable; urgency=medium

  * New upstream version 2.5.5
  * Bump Standards-Version
  * Bump binpac build-dependency
  * copyright: Add bits of Creative Commons license that are not strictly
    part of the license (thanks, Lintian)
  * Make build reproducible by removeing build path from *.bro files,
    thanks to Chris Lamb (Closes: #908379)

 -- Hilko Bengen <bengen@debian.org>  Wed, 05 Sep 2018 16:05:40 +0200

=== debian/control ===
Source: bro
Section: net
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Uploaders: Raúl Benencia <rul@kalgan.cc>
Build-Depends: debhelper (>= 10),
 cmake,
 binpac (>= 0.50),
 btest,
 bison,
 flex,
 rsync,
 libbind-dev,
 libcurl4-openssl-dev | libcurl-dev,
 libreadline-dev,
 libgeoip-dev,
 libgoogle-perftools-dev,
 libpcap0.8-dev | libpcap-dev,
 libsqlite3-dev,
 libssl-dev (>= 1.1),
 libxml2-dev,
 zlib1g-dev,
Standards-Version: 4.2.0
Homepage: http://www.bro.org
Vcs-Git: https://salsa.debian.org/git/bro-team/bro.git
Vcs-Browser: https://salsa.debian.org/bro-team/bro

Package: bro
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 bro-common
Built-Using: ${misc:Built-Using},
Description: passive network traffic analyzer
 Bro is primarily a security monitor that inspects all traffic on a link in
 depth for signs of suspicious activity. More generally, however, Bro
 supports a wide range of traffic analysis tasks even outside of the
 security domain, including performance measurements and helping with
 trouble-shooting.
 .
 Bro comes with built-in functionality for a range of analysis and
 detection tasks, including detecting malware by interfacing to external
 registries, reporting vulnerable versions of software seen on the network,
 identifying popular web applications, detecting SSH brute-forcing,
 validating SSL certificate chains, among others.

Package: bro-common
Architecture: all
Depends: ${misc:Depends}
Description: passive network traffic analyzer -- architecture-independent parts
 This package contains the architecture-independent parts for the Bro
 network security monitor.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake --builddir=build --parallel

override_dh_clean:
	-test -r debian/broken-symlinks.tar && tar -xf debian/broken-symlinks.tar
	dh_clean

override_dh_auto_configure:
	find -L -type l | xargs -r tar -cvf debian/broken-symlinks.tar | xargs -r rm
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DBINARY_PACKAGING_MODE=true

override_dh_install:
	mkdir -p debian/tmp/etc/bro
	mv debian/tmp/usr/share/bro/site debian/tmp/etc/bro/site
	find debian/tmp -type f -name '*.bro' -print0 | \
		xargs -0r sed -i -e 's@from $(CURDIR)/@from @g'
	dh_install --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vmisc:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W binpac)"
